import argparse

from flask import Flask, redirect, request
app = Flask(__name__)

## Wiki redirector
@app.route("/wiki/<path:path>")
def redirect_wiki (path):
    return redirect(make_wiki_url(path))

def is_wiki_directory_name (name):
    return "Dex" in name

def escape_wiki_page_name (page_name):
    page_name = page_name[0].upper() + page_name[1:].replace(" ", "_")

    if page_name.endswith("/"):
        page_name = page_name[:-1]

    if "/" in page_name:
        (prefix, suffix) = page_name.split("/", 1)
        suffix = suffix.replace("/", "%2F")
        page_name = prefix + ("/" if is_wiki_directory_name(prefix) else "%2F") + suffix

    return page_name

def make_wiki_url (path):
    url = app.args.wiki_archive

    if not url.endswith("/"):
        url = url + "/"

    return url + escape_wiki_page_name(path) + ".html"

## Forum redirector
@app.route('/forums/<path:path>')
def redirect_forums (path):
    return redirect(make_forum_url(path))

def make_forum_url (request):
    return str(request)

def main ():
    parser = argparse.ArgumentParser()
    parser.add_argument("--wiki-archive",  help="URL to wiki archive")
    parser.add_argument("--forums-archive",  help="URL to forums archive")

    app.args = parser.parse_args()
    app.run()